package br.com.caelum.vraptor.html.example.page;

import static br.com.caelum.vraptor.html.factories.PageTagFactory.css;
import static br.com.caelum.vraptor.html.factories.PageTagFactory.head;
import static br.com.caelum.vraptor.html.factories.PageTagFactory.html;
import static br.com.caelum.vraptor.html.factories.PageTagFactory.js;
import static br.com.caelum.vraptor.html.factories.PageTagFactory.title;
import br.com.caelum.vraptor.html.Page;
import br.com.caelum.vraptor.html.tags.interfaces.NestedElement;

public class DecoratorPage implements Page {

	private final Page decorated;

	public DecoratorPage(Page decorated) {
		this.decorated = decorated;
	}

	public NestedElement render() {
		return html().with(
					head().with(
						title().with("Page generated by VRaptor's HTML DSL"),
						css("/css/example.css"),
						js("https://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js"),
						js("/js/example.js")
					),
					decorated.render()
				);

	}

}
